#include "autorun.h"
#pragma hdrstop
#include <shellapi.h>
#include "execute.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

HANDLE __fastcall Execute(HWND hwnd,AnsiString op,AnsiString doc,AnsiString args,AnsiString dir,int nShow,AnsiString err);
void __fastcall Error(HWND hwnd,AnsiString msg,AnsiString doc,DWORD i);

HANDLE __fastcall ExecuteDocumentEx(AnsiString op,AnsiString doc)
{ return Execute(Application->Handle,op,doc,"","",SW_SHOW,"Error opening document");
}
HANDLE __fastcall OpenDocumentEx(AnsiString doc)
{ return Execute(Application->Handle,"open",doc,"","",SW_SHOW,"Error opening document");
}
HANDLE __fastcall OpenUrlEx(AnsiString url)
{ return Execute(Application->Handle,"open",url,"","",SW_SHOW,"Error opening URL");
}
HANDLE __fastcall OpenFolderEx(AnsiString doc)
{ return Execute(Application->Handle,"",doc,"","",SW_SHOW,"Error opening folder");
}
HANDLE __fastcall OpenCurrentFolderEx()
{ char c[MAX_PATH];
  GetModuleFileName(NULL,c,MAX_PATH);
  AnsiString doc=ExtractFilePath(c);
  return Execute(Application->Handle,"",doc,"","",SW_SHOW,"Error opening folder");
}

void __fastcall ExecuteProgram(AnsiString cmd) {CloseHandle(ExecuteProgramEx(cmd));}
void __fastcall ExecuteDocument(AnsiString operation,AnsiString doc) {CloseHandle(ExecuteDocumentEx(operation,doc));}
void __fastcall OpenDocument(AnsiString doc) {CloseHandle(OpenDocumentEx(doc));}
void __fastcall OpenUrl(AnsiString url) {CloseHandle(OpenUrlEx(url));}
void __fastcall OpenFolder(AnsiString doc) {CloseHandle(OpenFolderEx(doc));}
void __fastcall OpenCurrentFolder() {CloseHandle(OpenCurrentFolderEx());}

HANDLE __fastcall ExecuteProgramEx(AnsiString cmd)
{ STARTUPINFO si;
  si.cb=sizeof(si);
  si.lpReserved=NULL;
  si.lpDesktop=NULL;
  si.lpTitle=NULL,
  si.dwFlags=STARTF_FORCEONFEEDBACK;
  si.cbReserved2=0;
  si.lpReserved2=NULL;
  PROCESS_INFORMATION pi;
  BOOL bres=CreateProcess(NULL,cmd.c_str(),NULL,NULL,FALSE,0,NULL,NULL,&si,&pi);
  if (bres) return pi.hProcess;
  Error(Application->Handle,"Error executing command",cmd,GetLastError());
  return NULL;
}



void __fastcall Error(HWND hwnd,AnsiString strErr,AnsiString strDoc,DWORD iErr)
{
  LPVOID lpMsgBuf;
  FormatMessage(
      FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
      NULL,
      iErr,
      MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
      (LPTSTR) &lpMsgBuf,
      0,
      NULL
      );
  AnsiString s="Trying to open ";
  s=s+"\""+strDoc+"\"";
  s=s+"\r\n";
  s=s+AnsiString((char*)lpMsgBuf);
  LocalFree(lpMsgBuf);
  ::MessageBox(hwnd,s.c_str(),strErr.c_str(),MB_OK|MB_ICONEXCLAMATION);
}

HANDLE __fastcall Execute(HWND hwnd,AnsiString strOp,AnsiString strDoc,AnsiString strArgs,AnsiString strDir,int nShow,AnsiString strErr)
{ char *op=strOp.c_str(); if (*op==0) op=NULL;
  char *file=strDoc.c_str(); if (*file==0) file=NULL;
  char *param=strArgs.c_str(); if (*param==0) param=NULL;
  char *dir=strDir.c_str(); if (*dir==0) dir=NULL;
  SHELLEXECUTEINFO sei; ZeroMemory(&sei,sizeof(sei));
  sei.cbSize=sizeof(sei);
  sei.fMask=SEE_MASK_NOCLOSEPROCESS;
  sei.hwnd=hwnd;
  sei.lpVerb=op;
  sei.lpFile=file;
  sei.lpParameters=param;
  sei.lpDirectory=dir;
  sei.nShow=nShow;
  bool res=ShellExecuteEx(&sei);
  HINSTANCE hInstApp=sei.hInstApp;
  if ((int)hInstApp>32 && res) return sei.hProcess;
  Error(hwnd,strErr,strDoc,GetLastError());
  return NULL;
}


