#ifndef executeH
#define executeH


// EXECUTE/OPEN examples by Lucian Wischik. www.wischik.com/lu
// These routines are for executing other programs, opening documents and the like.
// Examples:
//   Execute("c:\\windows\\notepad.exe c:\\temp.txt");
//   ExecuteDocument("print","c:\\temp.txt");
//   OpenDocument("c:\\temp.txt");
//   OpenUrl("http://www.wischik.com/lu/programmer.html");
//   OpenFolder("c:\\windows");
//   OpenCurrentFolder();
// There are also 'ex' versions which return a process HANDLE. You might wait
// on this handle. Then you must close the handle. Win98 Explorer appears
// not to offer a valid handle for waiting on. I don't know why.
//   HANDLE h=Execute("c:\\windows\\notepad.exe c:\\temp.txt");
//   WaitForSingleObject(h,WAIT_INFINITE);
//   CloseHandle(h);
//

void __fastcall ExecuteProgram(AnsiString cmd);
void __fastcall ExecuteDocument(AnsiString operation,AnsiString doc);
void __fastcall OpenDocument(AnsiString doc);
void __fastcall OpenUrl(AnsiString url);
void __fastcall OpenFolder(AnsiString doc);
void __fastcall OpenCurrentFolder();


HANDLE __fastcall ExecuteProgramEx(AnsiString cmd);
HANDLE __fastcall ExecuteDocumentEx(AnsiString operation,AnsiString doc);
HANDLE __fastcall OpenDocumentEx(AnsiString doc);
HANDLE __fastcall OpenUrlEx(AnsiString url);
HANDLE __fastcall OpenFolderEx(AnsiString doc);
HANDLE __fastcall OpenCurrentFolderEx();





#endif
